Attribute VB_Name = "LUFactor"
Private Declare Sub LUSolve Lib "OCCdll.dll" (A As Double, B As Double, n As Long)
Private Declare Sub LUSolveS Lib "OCCdll.dll" (A As Double, B As Double, n As Long)
Function LinearSolve(av, bv)
    Dim n As Long
    Dim ncol As Long
    Dim nrow As Long
    Dim i As Long
    Dim j As Long
    Dim B() As Double
    Dim A() As Double
    Dim x() As Double
    ' this shows how to check size of nonsquare matrix, not necessary here
    n = av.Count
    ncol = av.EntireRow.Count
    nrow = n / ncol
    ReDim A(1 To nrow, 1 To ncol)
    ReDim B(1 To nrow)
    ReDim x(1 To nrow)
    For j = 1 To ncol
        For i = 1 To nrow
            A(i, j) = av(i, j)
        Next i
    Next j
    For i = 1 To nrow
        B(i) = bv(i)
    Next i
    If nrow = ncol Then
        Call LUSolve(A(1, 1), B(1), nrow)
    End If
    LinearSolve = Application.Transpose(B)
End Function
Function LinearSolveSym(av, bv)
' WARNING:  This code does not have the safe cards present in the one above
' May cause problems with the silly updates that Excel like to do
    Dim n As Long
    Dim ncol As Long
    Dim nrow As Long
    Dim i As Long
    Dim j As Long
    Dim B() As Double
    Dim A() As Double
    Dim x() As Double
    ' this shows how to check size of nonsquare matrix, not necessary here
    n = av.Count
    ncol = av.EntireRow.Count
    nrow = n / ncol
    ReDim A(1 To nrow, 1 To ncol)
    ReDim B(1 To nrow)
    ReDim x(1 To nrow)
    For j = 1 To ncol
        For i = 1 To nrow
            A(i, j) = av(i, j)
        Next i
    Next j
    For i = 1 To nrow
        B(i) = bv(i)
    Next i
    If nrow = ncol Then
        Call LUSolveS(A(1, 1), B(1), nrow)
    End If
    LinearSolveSym = Application.Transpose(B)
End Function
